import Matcher from '../domains/Matcher';
import { ImplicitThen } from '../domains/ThenFactory';
import { ImplicitWhen } from '../domains/WhenFactory';
export default class MatchAPI<S, D> {
    private value;
    private matcher;
    constructor(value?: S, matcher?: Matcher<S, D>);
    caseOf(when: ImplicitWhen<S>, then: ImplicitThen<S, D>): MatchAPI<S, D>;
    caseOf(param: {
        when: ImplicitWhen<S>;
        then: ImplicitThen<S, D>;
    }): MatchAPI<S, D>;
    caseOfNone(then: ImplicitThen<S, D>): MatchAPI<S, D>;
    caseOfNone(param: {
        then: ImplicitThen<S, D>;
    }): MatchAPI<S, D>;
    caseOfElse(then: ImplicitThen<S, D>): MatchAPI<S, D>;
    caseOfElse(param: {
        then: ImplicitThen<S, D>;
    }): MatchAPI<S, D>;
    end(): D;
    get(value?: S): D;
}
