var Matcher_1 = require('../domains/Matcher');
var CaseFactory_1 = require('../domains/CaseFactory');
var MatchAPI = (function () {
    function MatchAPI(value, matcher) {
        this.value = value;
        this.matcher = matcher;
        if (this.matcher === undefined) {
            this.matcher = new Matcher_1.default();
        }
    }
    MatchAPI.prototype.caseOf = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        return new MatchAPI(this.value, this.matcher.addCase((function (v) { return v.length === 1 ?
            CaseFactory_1.default.create(args[0]) :
            CaseFactory_1.default.create({ when: args[0], then: args[1] }); })(args)));
    };
    MatchAPI.prototype.caseOfNone = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        return new MatchAPI(this.value, this.matcher.addCase((function (v) { return v[0].then ?
            CaseFactory_1.default.createNone(args[0]) :
            CaseFactory_1.default.createNone({ then: args[0] }); })(args)));
    };
    MatchAPI.prototype.caseOfElse = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        return new MatchAPI(this.value, this.matcher.addCase((function (v) { return v[0].then ?
            CaseFactory_1.default.createElse(args[0]) :
            CaseFactory_1.default.createElse({ then: args[0] }); })(args)));
    };
    MatchAPI.prototype.end = function () {
        return this.matcher.match(this.value);
    };
    MatchAPI.prototype.get = function (value) {
        if (value === void 0) { value = this.value; }
        return this.matcher.match(value);
    };
    return MatchAPI;
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = MatchAPI;
//# sourceMappingURL=MatchAPI.js.map