var immutable_1 = require('immutable');
var Matcher = (function () {
    function Matcher(cases) {
        this.cases = cases;
        if (this.cases === undefined) {
            this.cases = immutable_1.List();
        }
    }
    Matcher.prototype.addCase = function (newCase) {
        return new Matcher(this.cases.push(newCase));
    };
    Matcher.prototype.match = function (value) {
        var match = this.cases.find(function (c) { return c.when.test(value); });
        return match ? match.then.exec(value) : undefined;
    };
    return Matcher;
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Matcher;
//# sourceMappingURL=Matcher.js.map